require(['config'], function() {
	require([
		'jquery'
	], function($) {

	});
});

let NK_PRODUCT_POP_GRID_LIST = '/api/nk/product/grid-list';
let NK_LIST_CLASS = '/api/nk/class/list-class'; // 카테고리리스트

function itp_fn_BIZPOP_NK_PRODUCT(parentPopFn, schParam, returnType) {
	
	// 브랜드그룹코드
	$('#ITP_FORM_BIZPOP_NK_PRODUCT_CMPY_CD').val(schParam.cmpyCd);
	$('#ITP_FORM_BIZPOP_NK_PRODUCT_BRAND_CD').val(schParam.brandCd);
	$('#ITP_FORM_BIZPOP_NK_PRODUCT_STORE_NO').val(schParam.storeNo);
	
	// 카테고리리스트
	itp_fn_BIZPOP_NK_PRODUCT_class_list();
	
	let itp_BIZPOP_NK_PRODUCT_param = {};
	let itp_BIZPOP_NK_PRODUCT_search = false;

	const THIS_FORM_ID = '#ITP_FORM_BIZPOP_NK_PRODUCT';
	const THIS_GIRD_ID = '#ITP_BIZPOP_NK_PRODUCT_jqGrid';
	const THIS_GIRD_PAGER = '#ITP_BIZPOP_NK_PRODUCT_jqGridPager';
	
	$('#ITP_BIZPOP_NK_PRODUCT').one('shown.bs.modal', function(e) {
		itp_fn_jqgrid_resize(THIS_GIRD_ID, '#ITP_BIZPOP_NK_PRODUCT_jqGrid_list', '');
		itp_fn_fire_window_resize();
	}).one('hidden.bs.modal', function(e) {
		$('#ITP_BIZPOP_NK_PRODUCT').remove();
	}).modal('show');

	$('#ITP_BIZPOP_NK_PRODUCT_BTN_SEARCH').on('click', function() {
		itp_BIZPOP_NK_PRODUCT_search = true;
		let param = $(THIS_FORM_ID).serializeObject();
		param.gridSize = 10;
		param.gridPage = $.jgrid.defaults.page;
		$(THIS_GIRD_ID).setGridParam({'postData': JSON.stringify(param)}).trigger('reloadGrid');
	});
	
	$('#ITP_BIZPOP_NK_PRODUCT_BTN_SELECT').on('click', function() {		
		const rowKey = $(THIS_GIRD_ID).getGridParam('selrow');
	    if (!rowKey) {
	    	return;
	    }

		var list = [];
	    var selectedIds = $(THIS_GIRD_ID).getGridParam('selarrrow');
		
	    for (var i=selectedIds.length-1; i>=0; i--) {
			list.push($(THIS_GIRD_ID).jqGrid('getRowData', selectedIds[i]));	
		}
		parentPopFn(list);
		$('#ITP_BIZPOP_NK_PRODUCT').modal('hide'); // 팝업닫기
	});

	$('#ITP_BIZPOP_NK_PRODUCT_jqGridEmpty').on('click', function() {
		itp_fn_BIZPOP_NK_PRODUCT_empty.back();
		itp_BIZPOP_NK_PRODUCT_param.gridSize = 10;
		$(THIS_GIRD_ID).setGridParam({'postData': JSON.stringify(itp_BIZPOP_NK_PRODUCT_param)}).trigger('reloadGrid');
	});

	var itp_fn_BIZPOP_NK_PRODUCT_empty = {
		push: function() {
			let param = $(THIS_FORM_ID).serializeObject();
			itp_BIZPOP_NK_PRODUCT_param = param;
		},
		back: function() {
			$(THIS_FORM_ID + '_CLASS_CD').val(itp_BIZPOP_NK_PRODUCT_param.sclassCd);
			$(THIS_FORM_ID + '_PRDT_NM').val(itp_BIZPOP_NK_PRODUCT_param.sprdtNm);
			$(THIS_FORM_ID + '_BARCODE_NO').val(itp_BIZPOP_NK_PRODUCT_param.sbarcodeNo);
		}
	};

	itp_fn_BIZPOP_NK_PRODUCT_empty.push();
	let param = $('#ITP_FORM_BIZPOP_NK_PRODUCT').serializeObject();
	param.gridSize = 10;

	$(THIS_GIRD_ID).jqGrid({
		colModel: [
			{
				index: 'CLASS_NM', name: 'classNm',
				label: '카테고리', 
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'PRDT_NO', name: 'prdtNo',
				label: '상품번호', // 
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'PRDT_NM', name: 'prdtNm',
				label: '상품명', // 
				width: '15', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'SALE_PRICE', name: 'salePrice',
				label: '상품가격', //
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: false, 
				formatter:'integer',formatoptions: { defaultValue: '', thousandsSeparator: ',' }
			},
			{
				index: 'BARCODE_NO', name: 'barcodeNo',
				label: '바코드', //
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: false
			}
		],
		loadBeforeSend: function(jqXHR) {
		    jqXHR.setRequestHeader('X-AUTH-TOKEN', CONN_KEY);
		},
		postData: JSON.stringify(param),
		url: DOMAIN + NK_PRODUCT_POP_GRID_LIST,
		pager: THIS_GIRD_PAGER,
		multiselect: true,
		loadComplete: function(data) {
			itp_fn_grid_load_complete(data, THIS_GIRD_ID, true, undefined, 'BIZPOP_NK_PRODUCT', itp_BIZPOP_NK_PRODUCT_search, itp_fn_BIZPOP_NK_PRODUCT_empty, true, data.gridRecords, false);
	    },
	    loadError: function(jqXHR, textStatus, errorThrown) {
	    	itp_fn_grid_load_error(jqXHR, textStatus, errorThrown);
	    },
	    onPaging: function(action) {
	    	itp_fn_grid_paging(THIS_GIRD_ID, action, param);
	    }
	}).navGrid(THIS_GIRD_PAGER, ITP_GRID_NAV_DEFAULTS.navGrid);
};

var itp_fn_BIZPOP_NK_PRODUCT_class_list = function() {
	const brandCdVal = $('#ITP_FORM_BIZPOP_NK_PRODUCT_BRAND_CD').val();
	const storeNoVal = $('#ITP_FORM_BIZPOP_NK_PRODUCT_STORE_NO').val();
	const key = {brandCd: brandCdVal, storeNo: storeNoVal};
	var param = $.param(key);
	fn_ajax_call(NK_LIST_CLASS, param, itp_fn_BIZPOP_NK_PRODUCT_class_list_callback, 'GET');
};

var itp_fn_BIZPOP_NK_PRODUCT_class_list_callback = function(result) {
	fn_make_select_class(result, 'ITP_FORM_BIZPOP_NK_PRODUCT_CLASS_CD', true, '카테고리'); 	
};
